
/* //////////////////// UTILITY FUNCTIONS //////////////////// */

function padSecondsWithLeadingZero(s) {
	if (s[1] === ".") { /* If the second character is a dot, it is necessarily something along the lines of "5.36" */
		if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer format") === "mm:ss.s") {
			return "0" + s.replace(".", ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer (milliseconds) text color").slice(0,2) + ".");
		}
		else {
			return "0" + Math.floor(s);
		}
	}
	else {
		if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer format") === "mm:ss.s") {
			return s.replace(".", ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer (milliseconds) text color").slice(0,2) + ".");
		}
		else {
			return Math.floor(s);
		}
	}
}

function romanize(num) {
  var lookup = {M:1000,CM:900,D:500,CD:400,C:100,XC:90,L:50,XL:40,X:10,IX:9,V:5,IV:4,I:1},roman = '',i;
  for ( i in lookup ) {
    while ( num >= lookup[i] ) {
      roman += i;
      num -= lookup[i];
    }
  }
  return roman;
}


var I18n = Java.type('net.minecraft.client.resources.I18n');  
function embellishEffectName(name) {
	/* Input must be playerEffects[i].getName() */
	if (typeof name === "string") {
		var localized = I18n.func_135052_a(name, '%s'); /*  I8n.format(name, '%s');   */
		return localized;     
	} 
}

function isBadEffect(fx) {
	var NegativePotionsID = [2, 4, 9, 15, 17, 18, 19, 20];
	if (NegativePotionsID.indexOf(fx.getID()) !== -1) {
		return true;
	}
	else {
		return false;
	}
}

function mapEffectToCorrespondingSettingName(fx) {
	switch (fx.getID()) {
		case 1:
		return "&7Show Speed";
		break;
		
		case 2:
		return "&7Show Slowness";
		break;
		
		case 3:
		return "Show Haste"
		
		case 4:
		return "Show Mining Fatigue";
		break;
		
		case 5:
		return "&7Show Strength";
		break;
		
		case 8:
		return "Show Jump Boost";
		break;
		
		case 9:
		return "&7Show Weakness";
		break;
		
		case 10:
		return "&7Show Regeneration";
		break;
		
		case 11:
		return "Show Resistance";
		break;
		
		case 12:
		return "&7Show Fire Resistance";
		break;
		
		case 13:
		return "Show Water Breathing";
		break;
		
		case 14:
		return "&7Show Invisibility";
		break;
		
		case 15:
		return "Show Nausea";
		break;
		
		case 16:
		return "Show Night Vision";
		break;
		
		case 17:
		return "&7Show Blindness";
		break;
		
		case 18:
		return "Show Hunger";
		break;
		
		case 19:
		return "&7Show Poison";
		break;
		
		case 20:
		return "Show Wither";
		break;
		
		case 21:
		return "&7Show Health Boost";
		break;
		
		case 22:
		return "Show Absorption";
		break;
		
		default:
		return "";
		break;
	}
}

/* //////////////////// UTILITY FUNCTIONS //////////////////// */

var xPosOfPotionEffects = Number(FileLib.read('./config/ChatTriggers/modules/ChoosyPotEffectHUD/savedxPosOfPotionEffects.txt'));
var yPosOfPotionEffects = Number(FileLib.read('./config/ChatTriggers/modules/ChoosyPotEffectHUD/savedyPosOfPotionEffects.txt'));

register("renderOverlay", function StatusEffectHUD() {
	if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "&7Enable the module") === true) {
		var o = 0; /* Creating another var than i to avoid gaps of hidden effects in the HUD */
		var playerEffects = Player.getActivePotionEffects();
		var i = playerEffects.length - 1;
		for (i; i >= 0; i--) {
			if (isBadEffect(playerEffects[i]) === true) {
				if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "&7Show negative effects") === false) {
					continue; /* you can immediately discard that potion effect and move on to potentially rendering the next on in the list of active potion effects */
				}
				/* negative effects aren't all hidden */
				else {
					
					/* if this specific pot effect has been set to be hidden, continue to the next iteration */
					if (ChoosyPotEffectSettings.getSetting("&4| &nNegative Effects&r &4|", mapEffectToCorrespondingSettingName(playerEffects[i])) === false) {
						continue;
					}
					
					/* this specific pot effect isn't set to be hidden */
					else {
						if (playerEffects[i].isDurationMax()) {
							
							/* if this effect has infinite duration and the user don't want effects with max durations to show, discard this effect and move on to the next */
							if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "&7Show effects with maximum duration") === false) {
								continue;
							}
							
							/* this effect passed all mandatory requirements for having a chance to appear on screen */
							/* now we look up the settings to see how to render that effect onto the screen */
							else {
								o++;
								
								/* If the Timer Format setting is not set to "none - hidden", this shall render the **:** timer onto the screen with the user's chosen colors, 
								else this just draws an empty string*/
								Renderer.drawStringWithShadow(
									ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer format").contains(":") ? 
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Timer (mm:ss) text color").slice(0,2) + "**:**" : "",
									xPosOfPotionEffects, (yPosOfPotionEffects + 10 + o*22));
									
								if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "Show Amplifier") === false) {
									/* draw the effect name without the amplifier */
									Renderer.drawStringWithShadow(
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
										embellishEffectName(playerEffects[i].getName()), xPosOfPotionEffects, (yPosOfPotionEffects+ o*22));
								}
								else {
									/* draw the effect name with the amplifier expressed in roman numerals */
									if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|","Numeral system for the amplifier").contains("Roman Numerals")) {
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + romanize(playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
									/* draw the effect name with the amplifier expressed in hindu-arabic numerals */
									else {
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + (playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
								}
							}
						}
						/* this bad effect does not have a max duration */
						else {
							/* hide the effect if its duration is higher than the amount of seconds set in settings by the user */
							if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|","Hide effects if their duration exceeds a certain value") === true &&
								playerEffects[i].getDuration()/20 > ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "&7Specify this value: (seconds)")) {
								continue;
							}
							/* This effect can be drawn onto the screen, we just need to precise how, in what format */
							else {
								o++;
								var potionEffectDurationInMinutes = playerEffects[i].getDuration() / 1200.0;
								var potionEffectDurationInSeconds = (potionEffectDurationInMinutes - Math.floor(potionEffectDurationInMinutes)) * 60.0;
								var minSecDuration = Math.floor(potionEffectDurationInMinutes) + ":" + padSecondsWithLeadingZero((potionEffectDurationInSeconds).toPrecision(3));
								/* this draws the timer onto the screen (if not set to be hidden by the Timer Format setting) with all necessary colors while 
								the padSecondsWithLeadingZero() function, inside the var minSecDuration, pads seconds with a leading zero and enforce the user's desired timer format*/
								Renderer.drawStringWithShadow(
									ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer format").contains(":") ?
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Timer (mm:ss) text color").slice(0,2) + minSecDuration : "", 
									xPosOfPotionEffects, 
									(yPosOfPotionEffects + 10 + o*22)
								);
								
								if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "Show Amplifier") === false) {
									/* draw the effect name without the amplifier */
									Renderer.drawStringWithShadow(
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
										embellishEffectName(playerEffects[i].getName()), xPosOfPotionEffects, (yPosOfPotionEffects+ o*22));
								}
								else {
									if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|","Numeral system for the amplifier").contains("Roman Numerals")) {
										/* draw the effect name with the amplifier expressed in roman numerals */
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + romanize(playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
									else {
										/* draw the effect name with the amplifier expressed in hindu-arabic numerals */
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + (playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
								}
							}
						}
					}
				}
			}
			/* This is not a bad effect, this is a positive effect (The process/code is the same as for rendering negative effects) */
			else {
				if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "Show positive effects") === false) {
					continue;
				}
				else {
					if (ChoosyPotEffectSettings.getSetting("&a| &nPositive Effects&r &a|", mapEffectToCorrespondingSettingName(playerEffects[i])) === false) {
						continue;
					}
					else {
						if (playerEffects[i].isDurationMax()) {
							if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "&7Show effects with maximum duration") === false) {
								continue;
							}
							else {
								o++;
								Renderer.drawStringWithShadow(
									ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer format").contains(":") ? 
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Timer (mm:ss) text color").slice(0,2) + "**:**" : "",
										
									xPosOfPotionEffects, (yPosOfPotionEffects + 10 + o*22));
								if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "Show Amplifier") === false) {
									Renderer.drawStringWithShadow(
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
										embellishEffectName(playerEffects[i].getName()), xPosOfPotionEffects, (yPosOfPotionEffects+ o*22));
								}
								else {
									if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|","Numeral system for the amplifier").contains("Roman Numerals")) {
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + romanize(playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
									else {
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + (playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
								}
							}
						}
						else {
							if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|","Hide effects if their duration exceeds a certain value") === true &&
								playerEffects[i].getDuration()/20 > ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "&7Specify this value: (seconds)")) {
								continue;
							}
							else {
								o++;
								var potionEffectDurationInMinutes = playerEffects[i].getDuration() / 1200.0;
								var potionEffectDurationInSeconds = (potionEffectDurationInMinutes - Math.floor(potionEffectDurationInMinutes)) * 60.0;
								var minSecDuration = Math.floor(potionEffectDurationInMinutes) + ":" + padSecondsWithLeadingZero((potionEffectDurationInSeconds).toPrecision(3));
								Renderer.drawStringWithShadow(
									ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "Timer format").contains(":") ?
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Timer (mm:ss) text color").slice(0,2) + minSecDuration : "", 
									xPosOfPotionEffects, 
									(yPosOfPotionEffects + 10 + o*22)
								);
								
								if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.1|", "Show Amplifier") === false) {
									Renderer.drawStringWithShadow(
										ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
										embellishEffectName(playerEffects[i].getName()), xPosOfPotionEffects, (yPosOfPotionEffects+ o*22));
								}
								else {
									if (ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|","Numeral system for the amplifier").contains("Roman Numerals")) {
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + romanize(playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
									else {
										Renderer.drawStringWithShadow(
											ChoosyPotEffectSettings.getSetting("&f| &nGeneral Settings&r&f p.2|", "&7Effect name color").slice(0,2) +
											embellishEffectName(playerEffects[i].getName()) + " " + (playerEffects[i].getAmplifier() + 1),
											xPosOfPotionEffects, 
											(yPosOfPotionEffects+ o*22)
										);
									}
								}
							}
						}
					}
				}
			}
		}
	}
});

register("clicked", function(mouseX, mouseY, mouseButton) {
	if (Client.isInChat()) {
		if (mouseButton === 0) { /* left click */
			if (xPosOfPotionEffects <= mouseX && mouseX < xPosOfPotionEffects + 60 && yPosOfPotionEffects <= mouseY && mouseY < yPosOfPotionEffects + 60) { /* check that the text is clicked */
				clickedAtThePotionEffectText = true;
			}
			else {
				clickedAtThePotionEffectText = false;
			}
		}
	}
});
register("dragged", function(dx, dy) {
	if (Client.isInChat()) {
		if (clickedAtThePotionEffectText) {
			xPosOfPotionEffects += dx
			yPosOfPotionEffects += dy
		}
	}
});

register("gameUnload", function saveCoordsOfPotionEffectsHUD() {
	FileLib.write('./config/ChatTriggers/modules/ChoosyPotEffectHUD/savedxPosOfPotionEffects.txt', xPosOfPotionEffects);
	FileLib.write('./config/ChatTriggers/modules/ChoosyPotEffectHUD/savedyPosOfPotionEffects.txt', yPosOfPotionEffects);
});