/*

This *NEEDS* to be loaded after Settings.js and SettingsObject.js
This will be handled automatically by metadata key "requires" as of 0.15

Creates a new SettingsObject and sets up the default values
This needs to be structured in a similar manner EG:
    array
        object
            name: string
            settings: array

*/
var ChoosyPotEffectSettings = new SettingsObject("ChoosyPotEffectHUD", [
    {
        name: "&f| &nGeneral Settings&r&f p.1|",
        settings: [
            new Setting.Toggle("&7Enable the module", true),
			new Setting.Toggle("Show positive effects", true),
			new Setting.Toggle("&7Show negative effects", true),
			new Setting.Toggle("Show Amplifier", true),
			new Setting.Toggle("&7Show effects with maximum duration", true),
			new Setting.Toggle("Hide effects if their duration exceeds a certain value", false),
			new Setting.Slider("&7Specify this value: (seconds)", 720, 1, 1639, 0),
			new Setting.TextInput("&7&l(i)&r &7You can click on the | Positive/Negative Effects | tabs to select what potion effects to show",""),
        ]
    },
    {
        name: "&f| &nGeneral Settings&r&f p.2|",
        settings: [
			new Setting.StringSelector("Numeral system for the amplifier", 0, [
                "Roman Numerals (I, II, III, IV, ..., IX, X, ...)", 
                "Hindu-Arabic Numerals (1, 2, 3, 4, ..., 9, 10, ....)"
            ]),
			new Setting.StringSelector("&7Effect name color", 3, [
				"&0Black",
				"&8Dark Grey",
				"&7Light Grey",
				"&fWhite",
				"&5Dark Purple",
				"&dLight Purple",
				"&9Light Blue",
				"&1Dark Blue",
				"&3Dark Aqua",
				"&bLight Aqua",
				"&aLight Green",
				"&2Dark Green",
				"&6Gold","&eYellow",
				"&cLight Red",
				"&4Dark Red"
			]),
			new Setting.StringSelector("Timer format", 0, [
				"mm:ss.s",
				"mm:ss",
				"none - hidden"
			]),
			new Setting.StringSelector("&7Timer (mm:ss) text color", 3, [
				"&0Black",
				"&8Dark Grey",
				"&7Light Grey",
				"&fWhite",
				"&5Dark Purple",
				"&dLight Purple",
				"&9Light Blue",
				"&1Dark Blue",
				"&3Dark Aqua",
				"&bLight Aqua",
				"&aLight Green",
				"&2Dark Green",
				"&6Gold","&eYellow",
				"&cLight Red",
				"&4Dark Red"
			]),
			new Setting.StringSelector("Timer (milliseconds) text color", 2, [
				"&0Black",
				"&8Dark Grey",
				"&7Light Grey",
				"&fWhite",
				"&5Dark Purple",
				"&dLight Purple",
				"&9Light Blue",
				"&1Dark Blue",
				"&3Dark Aqua",
				"&bLight Aqua",
				"&aLight Green",
				"&2Dark Green",
				"&6Gold","&eYellow",
				"&cLight Red",
				"&4Dark Red"
			]),
			new Setting.TextInput("&7&l(i)&r &7You can drag the Status Effect HUD around the screen with your cursor while in chat",""),
            new Setting.Button("&4Reset settings", "&4Click here to reset", function() {
                ChoosyPotEffectSettings.reset();
                ChoosyPotEffectSettings.load();
            })
        ]
    },
	{
        name: "&a| &nPositive Effects&r &a|",
        settings: [
            new Setting.Toggle("&7Show Speed", true),
			new Setting.Toggle("Show Haste", true),
			new Setting.Toggle("&7Show Strength", true),
			new Setting.Toggle("Show Jump Boost", true),
			new Setting.Toggle("&7Show Regeneration", true),
			new Setting.Toggle("Show Resistance", true),
			new Setting.Toggle("&7Show Fire Resistance", true),
			new Setting.Toggle("Show Water Breathing", true),
			new Setting.Toggle("&7Show Invisibility", true),
			new Setting.Toggle("Show Night Vision", true),
			new Setting.Toggle("&7Show Health Boost", true),
			new Setting.Toggle("Show Absorption", true)
        ]
    },
	{
        name: "&4| &nNegative Effects&r &4|",
        settings: [
            new Setting.Toggle("&7Show Slowness", true),
			new Setting.Toggle("Show Mining Fatigue", true),
			new Setting.Toggle("&7Show Weakness", true),
			new Setting.Toggle("Show Nausea", true),
			new Setting.Toggle("&7Show Blindness", true),
			new Setting.Toggle("Show Hunger", true),
			new Setting.Toggle("&7Show Poison", true),
			new Setting.Toggle("Show Wither", true)
			
		]
    }
]);

/* Optional modifications */
ChoosyPotEffectSettings.setCommand("choosypoteffecthud").setSize(400, 250).setColor(Renderer.color(9,9,13));
ChoosyPotEffectSettings.setCommand("choosypot").setSize(400, 250).setColor(Renderer.color(9,9,13));

/* Registers the SettingsObject (this is REQUIRED) */
Setting.register(ChoosyPotEffectSettings);